'***********************************************************************
'
'    Filename        :     Multisteckdose		
'    File Version    :     1.0
'    Datum           :     06.04.2008            	
'    Autor           :     Peter Verderber		
'    Funktion        :     Multifunktions-Steckdose		
'    Letzte Revision :     1.0
'    Datum           :     06.04.2008           
'    Ziel PIC        :     iL-Troll (16F872) 	
'    Compiler        :     iL_BAS16 - iL_Troll V5.7-3  20.02.2007 
'    
'***********************************************************************
'*****                Definitionen und Konstanten                  *****
'***********************************************************************

Date
Time

$NCALDEF
         
DEFINE device iL_Troll
                  
       tris rc,%11111111
       tris rb,%00000000          
             
       output rb,%00000000
 
'$debug 
 
define dil_S1         = auto as byte   'Zeit an S1
define dil_S2         = auto as byte   'Trigger & Funktion an S2         
define licht          = auto as byte   'Lichtintensitt
define sensitive      = auto as byte   'Sensitivitt Lookup-Tabelle       
define volt           = auto as byte   'Spannung
define watt           = auto as byte   'Leistung Lookup-Tabelle    
define zeit           = auto as byte   'Sekundentakt        
define minuten        = auto as byte   'Anzahl Minuten
define store_S1       = auto as byte   'DIL-Schalter1 speichern
define store_S2       = auto as byte   'DIL-Schalter2 speichern
define menu           = auto as byte   'Menu-Auswahl        
define nn             = auto as byte   'Hilfsvariablen
define mm             = auto as byte 
define zz             = auto as byte       
 
define var_trig       = auto as byte   'DIL S2 Trigger
define var_trig1      = auto as byte
define var_trig2      = auto as byte
define var_trig4      = auto as byte
define var_trig8      = auto as byte

define var_menu1      = auto as byte   'DIL S2 Menu
define var_menu2      = auto as byte
define var_menu4      = auto as byte
define var_menu8      = auto as byte

define switch1        = rb,7           'DIL-S1 abfragen
define switch2        = rb,6           'DIL-S2 abfragen 
define summer         = rb,5           'Strung Summer
define fault_led      = rb,4           'Strung LED-Anzeige
define fault_relais   = rb,3           'Strung Relais
define slave_relais   = rb,2           'Slave Relais
define trigger_led    = rb,1           'Trigger-Level-Anzeige 
define sekunden_led   = rb,0           'Sekunden-Anzeige

define P0  =   3 as const              'P = ca.   40 Watt   
define P1  =   6 as const              'P = ca.   60 Watt 
define P2  =  11 as const              'P = ca.   80 Watt 
define P3  =  33 as const              'P = ca.  190 Watt           
define P4  =  50 as const              'P = ca.  270 Watt 
define P5  =  79 as const              'P = ca.  380 Watt 
define P6  = 102 as const              'P = ca.  480 Watt 
define P7  = 117 as const              'P = ca.  570 Watt 
define P8  = 125 as const              'P = ca.  600 Watt 
define P9  = 137 as const              'P = ca.  730 Watt 
define P10 = 160 as const              'P = ca. 1000 Watt 
define P11 = 170 as const              'P = ca. 1250 Watt 
define P12 = 190 as const	       'P = ca. 2100 Watt       
define P13 = 197 as const              'P = ca. 2500 Watt 
define P14 = 203 as const              'P = ca. 3100 Watt 
define P15 = 206 as const              'P = ca. 3300 Watt

define L0  =  15 as const              'L =   6,25 %   
define L1  =  31 as const              'L =  12,50 % 
define L2  =  47 as const              'L =  18,75 %
define L3  =  63 as const              'L =  25,00 %           
define L4  =  79 as const              'L =  31,25 % 
define L5  =  95 as const              'L =  37,50 % 
define L6  = 111 as const              'L =  43,75 % 
define L7  = 127 as const              'L =  50,00 % 
define L8  = 143 as const              'L =  56,25 % 
define L9  = 159 as const              'L =  62,50 %  
define L10 = 175 as const              'L =  68,75 %  
define L11 = 191 as const              'L =  75,00 % 
define L12 = 207 as const	       'L =  81,25 %       
define L13 = 223 as const              'L =  87,50 %  
define L14 = 239 as const              'L =  93,75 % 
define L15 = 255 as const              'L = 100,00 % 

goto main                              'Start Hauptprogramm

'***********************************************************************
'*****                   Unterprogramme                            *****
'***********************************************************************

init:                         'Variablen initalisieren
  output rb,%00000000

  let dil_S1    = 0
  let dil_S2    = 0
  Let licht     = 0         
  let volt      = 0
  let sensitive = 0
  let watt      = 0   
  let zeit      = 0
  let minuten   = 0
  let store_S1  = 0
  let store_S2  = 0
  let nn        = 0  
  let mm        = 0  
  let zz        = 0
  
  let var_trig  = 0   
  let var_trig1 = 0
  let var_trig2 = 0
  let var_trig4 = 0
  let var_trig8 = 0
  
  let menu      = 0
  let var_menu1 = 0
  let var_menu2 = 0
  let var_menu4 = 0
  let var_menu8 = 0
      
  return       

'----------------------------------------------------------------------- 

menu0:                        'Triggerschwelle
  output rb,%00000000 
  
  menu0_loop: 
    gosub lookup_power
    gosub sek_takt_led
    gosub read_dil
    
    if dil_S1 <> store_S1 then goto exit_m0_loop
    if dil_S2 <> store_S2 then goto exit_m0_loop
    
    adinp 0,volt              'Messung der aktuellen Leistung
         
    if volt > watt then set trigger_led else res trigger_led
    
    goto menu0_loop
    
  exit_m0_loop:
    output rb,%00000000       'reset Trigger-Led 
                
  return

'----------------------------------------------------------------------- 

menu1:                        'Strmelder
  output rb,%00000000 
  gosub start_sound
  gosub lookup_power
      
  menu1_loop:
    gosub sek_takt_led
    
    gosub read_dil
    if dil_S1 <> store_S1 then goto exit_m1_loop
    if dil_S2 <> store_S2 then goto exit_m1_loop
    
    if store_S1 = 0 then goto exit_m1_loop       'Zeitfenster gewhlt?
    
    adinp 0,volt              'Messung der aktuellen Leistung
    
    inc zeit
    if zeit = 60 then gosub mein_timer
    
    if volt > watt then let minuten = 0
    if minuten >= store_S1 then goto alarm_on_loop else goto menu1_loop   
        
    alarm_on_loop:
      output rb,%00111000    'set Alarm-Relais & Strung-LED & Summer
      wait 500
      output rb,%00001000    'reset Strung-LED & Summer 
      wait 1000        
      goto alarm_on_loop
    
  exit_m1_loop:
    output rb,%00000000       'reset Trigger-Led & Slave-Relais
    gosub error_sound   
            
  return

 '-----------------------------------------------------------------------

menu2:                        'Ausschalt-Timer
  output rb,%00000110         'set Trigger-LED & Slave-Rlais
  gosub start_sound
  
  menu2_loop:
    gosub sek_takt_led
    
    if minuten = store_S1 then goto relais_off_loop
        
    gosub read_dil
    if dil_S1 <> store_S1 then goto exit_m2_loop
    if dil_S2 <> store_S2 then goto exit_m2_loop
    
    if store_S1 = 0 then goto exit_m2_loop       'Zeitfenster gewhlt?
    
    inc zeit     
    if zeit = 60 then gosub mein_timer 
    
    goto menu2_loop
  
  relais_off_loop:
    output rb,%00000000       'reset Trigger-Led & Slave-Relais      
    goto relais_off_loop  
  
  exit_m2_loop:
    gosub error_sound
         
  return

'-----------------------------------------------------------------------

menu3:                        'Einschalt-Timer
  output rb,%00000000         'reset Trigger-Led & Slave-Relais
  gosub start_sound
  
  menu3_loop:
    gosub sek_takt_led
    
    if minuten = store_S1 then goto relais_on_loop
        
    gosub read_dil
    if dil_S1 <> store_S1 then goto exit_m3_loop
    if dil_S2 <> store_S2 then goto exit_m3_loop
    
    if store_S1 = 0 then goto exit_m3_loop       'Zeitfenster gewhlt?
    
    inc zeit
    if zeit = 60 then gosub mein_timer
                     
    goto menu3_loop
  
  relais_on_loop:
    output rb,%00000110      'set Trigger-Led & Slave-Relais
    goto relais_on_loop  
  
  exit_m3_loop:
    gosub error_sound
         
  return

'-----------------------------------------------------------------------

menu4:                       'Master-Slave
  output rb,%00000000        'reset Trigger-Led & Slave-Relais
  gosub start_sound
  gosub lookup_power
      
  menu4_loop:
    gosub sek_takt_led
    
    gosub read_dil
    if dil_S1 <> store_S1 then goto exit_m4_loop
    if dil_S2 <> store_S2 then goto exit_m4_loop
    
    adinp 0,volt             'Messung der aktuellen Leistung
    
    if volt >= watt then goto slave_on_loop else goto slave_off_loop
    
    slave_on_loop:
      output rb,%00000110    'set Trigger-Led & Slave-Relais
      wait 1500
      goto menu4_loop
    
    slave_off_loop:
      output rb,%00000000    'reset Trigger-Led & Slave-Relais
      wait 1500
      goto menu4_loop
     
  exit_m4_loop:
    output rb,%00000000      'reset Trigger-Led & Slave-Relais
    gosub error_sound   
            
  return

'-----------------------------------------------------------------------

menu5:                       'Blinken im Sekunden-Takt
  output rb,%00000000        'reset Trigger-Led & Slave-Relais
  gosub start_sound
  
  gosub read_dil
  if dil_S1 <> store_S1 then goto exit_m5_loop
  if dil_S2 <> store_S2 then goto exit_m5_loop  
  
  if store_S1 = 0 then goto exit_m5_loop       'Zeitfenster gewhlt?
    
  menu5_loop: 
    for mm = 1 to store_S1
      gosub read_dil
      if dil_S1 <> store_S1 then goto exit_m5_loop
      if dil_S2 <> store_S2 then goto exit_m5_loop 
      
      if store_S1 = 0 then goto exit_m5_loop       'Zeitfenster gewhlt?    
      
      output rb,%00000110    'set Trigger-Led & Slave-Relais
      gosub sek_takt_led
     next mm
    
    for mm = 1 to store_S1
      gosub read_dil
      if dil_S1 <> store_S1 then goto exit_m5_loop
      if dil_S2 <> store_S2 then goto exit_m5_loop
      
      if store_S1 = 0 then goto exit_m5_loop       'Zeitfenster gewhlt?
      
      output rb,%00000000    'reset Trigger-Led & Slave-Relais
      gosub sek_takt_led
    next mm
      
    goto menu5_loop
    
  exit_m5_loop:
    output rb,%00000000      'reset Trigger-Led 
    gosub error_sound
                
  return

'-----------------------------------------------------------------------

menu6:                       'Blinken im Minuten-Takt
  output rb,%00000000        'reset Trigger-Led & Slave-Relais
  gosub start_sound
    
  gosub read_dil
  if dil_S1 <> store_S1 then goto exit_m6_loop
  if dil_S2 <> store_S2 then goto exit_m6_loop  
  
  if store_S1 = 0 then goto exit_m6_loop       'Zeitfenster gewhlt?
    
  menu6_loop: 
    for mm = 1 to store_S1
      gosub read_dil
      if dil_S1 <> store_S1 then goto exit_m6_loop
      if dil_S2 <> store_S2 then goto exit_m6_loop     
      
      if store_S1 = 0 then goto exit_m6_loop       'Zeitfenster gewhlt?
      
      output rb,%00000110    'set Trigger-Led & Slave-Relais
            
      for zz = 1 to 60
        gosub sek_takt_led
      next zz
      
    next mm
    
    for mm = 1 to store_S1
      gosub read_dil
      if dil_S1 <> store_S1 then goto exit_m6_loop
      if dil_S2 <> store_S2 then goto exit_m6_loop
      
      if store_S1 = 0 then goto exit_m6_loop       'Zeitfenster gewhlt?
      
      output rb,%00000000    'reset Trigger-Led & Slave-Relais
      
      for zz = 1 to 60      
        gosub sek_takt_led
      next zz  
             
    next mm
      
    goto menu6_loop
    
  exit_m6_loop:
    output rb,%00000000      'reset Trigger-Led 
    gosub error_sound
                
  return

'----------------------------------------------------------------------- 

menu7:                       'Licht dunkel => Relaiskontakt geschlossen                                  
  output rb,%00000000        'reset Trigger-Led & Slave-Relais
  gosub start_sound
    
  menu7_loop: 
    gosub lookup_sensitiv
    gosub sek_takt_led
    
    gosub read_dil
    if dil_S1 <> store_S1 then goto exit_m7_loop
    if dil_S2 <> store_S2 then goto exit_m7_loop
    
    adinp 1,licht            'Messung der aktuellen Lichtintensitt
         
    if licht > sensitive then goto slavem7_on_loop else goto slavem7_off_loop
       
    slavem7_on_loop:
      output rb,%00000110    'set Trigger-Led & Slave-Relais
      wait 1500
      goto menu7_loop
   
    slavem7_off_loop:
      output rb,%00000000    'reset Trigger-Led & Slave-Relais
      wait 1500
      goto menu7_loop
    
   exit_m7_loop:
     output rb,%00000000     'reset Trigger-Led & Slave-Relais
     gosub error_sound 
                
  return

'----------------------------------------------------------------------- 

menu8:                       'Licht hell => Relaiskontakt geschlossen                                  
  output rb,%00000000        'reset Trigger-Led & Slave-Relais
  gosub start_sound
  
  menu8_loop: 
    gosub lookup_sensitiv
    gosub sek_takt_led
    
    gosub read_dil
    if dil_S1 <> store_S1 then goto exit_m8_loop
    if dil_S2 <> store_S2 then goto exit_m8_loop
    
    adinp 1,licht            'Messung der aktuellen Lichtintensitt
         
    if licht < sensitive then goto slavem8_on_loop else goto slavem8_off_loop
       
    slavem8_on_loop:
      output rb,%00000110    'set Trigger-Led & Slave-Relais
      wait 1500
      goto menu8_loop
    
    slavem8_off_loop:
      output rb,%00000000    'reset Trigger-Led & Slave-Relais
      wait 1500
      goto menu8_loop
    
   exit_m8_loop:
     output rb,%00000000     'reset Trigger-Led & Slave-Relais
     gosub error_sound 
                
  return

'----------------------------------------------------------------------- 

read_dil:                    'Abfrage von DIL1 & DIL2 
  set switch1                          
  input rc, dil_S1
  let dil_S1 = dil_S1 xor %11111111
  res switch1  
  
  wait 10
     
  set switch2
  input rc, dil_S2
  let dil_S2 = dil_S2 xor %11111111
  res switch2
  
  return
  
'-----------------------------------------------------------------------         

store_dil:                   'Speicherung von DIL1 & DIL2
  let store_S1 = dil_S1
  let store_S2 = dil_S2
    
  return
  
'-----------------------------------------------------------------------         

dil_menu:                    'DIL S2 Menu-Auswahl
  let menu      = 0          
  let var_menu1 = 0
  let var_menu2 = 0
  let var_menu4 = 0
  let var_menu8 = 0 
                                                 
  if store_S2,7 = 1 then let var_menu8 = 8       'Menu 2^8
  if store_S2,6 = 1 then let var_menu4 = 4       'Menu 2^4
  if store_S2,5 = 1 then let var_menu2 = 2       'Menu 2^2
  if store_S2,4 = 1 then let var_menu1 = 1       'Menu 2^1

  let menu = var_menu8 + var_menu4 + var_menu2 + var_menu1
  
  if menu > 8 then gosub error_menu    'Menu-Auswahl gltig?
  
  return

'-----------------------------------------------------------------------

trigger_schwelle:            'DIL S2 Trigger-Schwelle
  let var_trig  = 0   
  let var_trig1 = 0
  let var_trig2 = 0
  let var_trig4 = 0
  let var_trig8 = 0                              
 
  if store_S2,3 = 1 then let var_trig8 = 8       'Trigger 2^8
  if store_S2,2 = 1 then let var_trig4 = 4       'Trigger 2^4
  if store_S2,1 = 1 then let var_trig2 = 2       'Trigger 2^2
  if store_S2,0 = 1 then let var_trig1 = 1       'Trigger 2^1
  
  let var_trig = var_trig8 + var_trig4 + var_trig2 + var_trig1
  
  return

'-----------------------------------------------------------------------         

start_sound:                 'akustisches Startsignal
    set summer                           
    wait 400      
    res summer
   
  return

'-----------------------------------------------------------------------         

error_sound:                 'akustisches Fehlersignal
  for nn = 1 to 4
    set summer                           
    wait 400  
    res summer
    wait 200
  next nn  
     
  return

'-----------------------------------------------------------------------         

mein_timer:                  'Minuten Zhler
  inc minuten
  let zeit = 0        
    
  return
  
'----------------------------------------------------------------------- 

sek_takt_led:                'Anzeige Sekundentakt
  set sekunden_led
  wait 494
  res sekunden_led
  wait 494

  return
         
'-----------------------------------------------------------------------

error_menu:                  'Anzeige ungltige Menu-Auswahl
  set sekunden_led
  set fault_led
  wait 125
  res sekunden_led
  res fault_led
  wait 125

  return

'-----------------------------------------------------------------------  

lookup_power:                'Konstanten - Leistung (W) in Digit
  gosub trigger_schwelle
  lookup watt,var_trig,P0,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11,P12,P13,P14,P15
  
  return
  
'-----------------------------------------------------------------------  

lookup_sensitiv:             'Konstanten - Sensitivitt (%) in Digit
  gosub trigger_schwelle
  lookup sensitive,var_trig,L0,L1,L2,L3,L4,L5,L6,L7,L8,L9,L10,L11,L12,L13,L14,L15
  
  return
  

'***********************************************************************
'*****                     Hauptprogramm                           *****
'***********************************************************************

main:
  gosub init                 'Variablen initialisieren
  
  loop:                                
    gosub read_dil           'DIL S1 & DIL S2 abfragen          
    gosub store_dil          'DIL Schalterstellungen abspeichern          
    gosub dil_menu           'gewhltes Menu ermitteln     
     
    ON menu GOSUB menu0,menu1,menu2,menu3,menu4,menu5,menu6,menu7,menu8
                                       
         'Menu 0 Triggerschwelle ermitteln fr Menu 1
         'Menu 1 Strmelder
         'Menu 2 Ausschalt-Timer 
         'Menu 3 Einschalt-Timer
         'Menu 4 Master-Slave
         'Menu 5 Blinken im Sekunden-Takt
         'Menu 6 Blinken im Minuten-Takt
         'Menu 7 zunehmende Dunkelheit => Relaiskontakt geschlossen 
         'Menu 8 zunehmende Helligkeit => Relaiskontakt geschlossen  
                                     
    goto loop
         
  end                        'Ende gut, alles gut       
        
       